/*
Copyright 2006 Frank van der Loo

This file is part of Paratim.

Paratim is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Paratim is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Paratim; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef CHOPPER_H
#define CHOPPER_H

#include <iostream>
#include "SDL.h"
#include "sprite.h"
//#include "llist.h"
#include "trooper.h"

const int NUM_OF_CHOP = 6;
const int CHOPPER_SPEED = 3;
const int LEFT_CHOPPER_Y = 100;
const int RIGHT_CHOPPER_Y = 5;

class chopper: public sprite
{
	private:
		int points;
		bool end;
		Direction dir;

	public:
		chopper(int x, Direction d);
		int getPoints() { return points; }
		void move(bool plane, SDL_Surface *screen);
		bool getEnd() { return end; }
		void hit(SDL_Surface *screen);
		Direction getDirection() { return dir; }
		bool drop_trooper();
		bool visible();
};

#endif
