/*
Copyright 2006 Frank van der Loo

This file is part of Paratim.

Paratim is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Paratim is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Paratim; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include "SDL.h"
#include "gun.h"

// Creates a new gun
gun::gun(const char path[], const char file[]) : sprite(path, file)
{
	#ifdef DEBUG
	  std::cout << "In gun constructor\n";
	#endif
	angle = 0;
	src.x = angle+900;
	src.y = 0;
	src.w = 100;
	src.h = 100;

	dst.x = 350;
	dst.y = 330;

	black.w = src.w + 1;
	black.h = src.h + 1;
	black.x = dst.x - 1;
	black.y = dst.y - 1;

	base.w = 100;
	base.h = 100;
	base.x = 350;
	base.y = 450;

	base_top.w = 10;
	base_top.h = 100;
	base_top.x = 395;
	base_top.y = 350;
}

// Rotates the gun to the left
void gun::left()
{
	if (angle > -900)
	{
		angle -= 50;
		if (!(angle%100))
		{
			src.x = angle+900;
		}
	}
}

// Rotates the gun to the right
void gun::right()
{
	if (angle < 900)
	{
		angle += 50;
		if (!(angle%100))
		{
			src.x = angle+900;
			if (angle == 900)
				src.x = 0;
		}
	}
}

void showGun(SDL_Surface *screen, gun player_gun)
{
	SDL_Rect gunsrctemp = player_gun.getSrcRect();
	SDL_Rect gundsttemp = player_gun.getDstRect();
	SDL_Rect gunBaseSrcTemp = player_gun.getBaseRect();
	SDL_Rect gunBaseTopSrcTemp = player_gun.getBaseTopRect();
	SDL_FillRect(screen, &gunBaseSrcTemp, SDL_MapRGB(screen->format, 255, 255, 255));
	SDL_FillRect(screen, &gunBaseTopSrcTemp, SDL_MapRGB(screen->format, 255, 255, 255));
	SDL_BlitSurface(player_gun.getSurface(), &gunsrctemp, screen, &gundsttemp);
}
