/*
Copyright 2006 Frank van der Loo

This file is part of Paratim.

Paratim is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Paratim is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Paratim; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef TROOPER_H
#define TROOPER_H

#include <iostream>
#include "SDL.h"
#include "sprite.h"
//#include "llist.h"

class linkedList2;

enum trooper_state{DROPPED, FLOATING, LANDED, FALLING, END};
const short FALL_SPEED = 5;
const short FLOATING_FALL_SPEED = 2;

class trooper: public sprite
{
	private:
		SDL_Surface *image2;
		SDL_Rect dst2, black2;
		int points;
		//bool end, falling;
		trooper_state state;
		int open_parachute_y;
	public:
		trooper(int x, int y);
		SDL_Rect getDst2Rect() { return dst2; }
		void setDst2Rect(SDL_Rect rect){ dst2 = rect; }
		SDL_Rect getBlack2() { return black2; }
		SDL_Surface *getSurface2() { return image2; }
		int getPoints() { return points; }
		int move(SDL_Surface *screen, trooper* landed_troopers[]);
		//bool getEnd() {return end;};
		void hit() { state = END; }
		void fall() { state = FALLING; speed = FALL_SPEED; }
		//bool getFalling(){return falling;};
		trooper_state getState() { return state; }
		void open_parachute() { state = FLOATING; speed = FLOATING_FALL_SPEED; }
};

bool four_troopers(trooper* landed_troopers[]);
int drops_on_trooper(SDL_Surface *screen, trooper*, trooper* landed_troopers[]);
void concatenate(int index, trooper* landed_troopers[]);
int move_troopers(linkedList2 &troopLList, SDL_Surface *screen, trooper* landed_troopers[]);

#endif
