/*
Copyright 2006 Frank van der Loo

This file is part of Paratim.

Paratim is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

Paratim is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with Paratim; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#include <iostream>
#include "SDL.h"
#include "txt2sdl.h"

using namespace std;

// puts a string on the screen as SDL and returns the endposition
int txt2sdl(string str, int x_pos, int y_pos, SDL_Surface *chars, SDL_Surface *screen)
{
	SDL_Rect src, dst;
	src.y = 0;
	src.h = 39;
	dst.x = x_pos;
	dst.y = y_pos;
	for (unsigned int i=0;i<str.length();i++)
	{
		if (str[i] >= 'A' && str[i] <= 'Z')
		{
			src.x = char_begin_width[0][str[i] - 65];
			src.w = char_begin_width[1][str[i] - 65];
		}
		else if (str[i] == ':')
		{
			src.x = char_begin_width[0][36];
			src.w = char_begin_width[1][36];
		}
		else if (str[i] >= '0' && str[i] <= '9')
		{
			src.x = char_begin_width[0][(str[i] - 48) + 26];
			src.w = char_begin_width[1][(str[i] - 48) + 26];
		}
		else if (str[i] == ' ')
		{
			src.w = 0;
			dst.x += 17;
		}
		SDL_BlitSurface(chars, &src, screen, &dst);
		dst.x += src.w;
		dst.x += 3;
	}
	return dst.x;
}

// put a c-string on the screen as SDL and returns the endposition
int txt2sdl(const char str[], int x_pos, int y_pos, SDL_Surface *chars, SDL_Surface *screen)
{
	return txt2sdl((string)str, x_pos, y_pos, chars, screen);
	/*SDL_Rect src, dst;
	src.y = 0;
	src.h = 39;
	dst.x = x_pos;
	dst.y = y_pos;
	for (unsigned int i=0;i<strlen(str);i++)
	{
		if (str[i] >= 'A' && str[i] <= 'Z')
		{
			src.x = char_begin_width[0][str[i] - 65];
			src.w = char_begin_width[1][str[i] - 65];
		}
		else if (str[i] == ':')
		{
			src.x = char_begin_width[0][36];
			src.w = char_begin_width[1][36];
		}
		else if (str[i] >= '0' && str[i] <= '9')
		{
			src.x = char_begin_width[0][(str[i] - 48) + 26];
			src.w = char_begin_width[1][(str[i] - 48) + 26];
		}
		else if (str[i] == ' ')
		{
			src.w = 0;
			dst.x += 17;
		}
		SDL_BlitSurface(chars, &src, screen, &dst);
		dst.x += src.w;
		dst.x += 3;
	}
	return dst.x;*/
}

// puts an integer on the screen as SDL
void int2sdl(int number, int x_pos, int y_pos, SDL_Surface *chars, SDL_Surface *screen)
{
	SDL_Rect src, dst;
	src.y = 0;
	src.h = 39;
	dst.x = x_pos;
	dst.y = y_pos;
	string num = "";
	while (number != 0)
	{
		num = (char)((number%10)+48) + num;
		number /= 10;
	}
	txt2sdl(num, x_pos, y_pos, chars, screen);
}
